<template>
  <div
    class="alert flex flex-col justify-center items-baseline"
    :class="alertSelector"
  >
    <h2 class="card-title">
      {{ textRoot ? $t(`${textRoot}.${alertType}.title`) : title }}
    </h2>
    <p class="text-left">
      {{ textRoot ? $t(`${textRoot}.${alertType}.text`) : text }}
    </p>
  </div>
</template>

<script lang="ts">
import Vue from 'vue'
import { AlertType } from '~/utility/constant'

export default Vue.extend({
  props: {
    title: { type: String, default: '' },
    text: { type: String, default: '' },
    textRoot: { type: String, default: '' },
    alertType: {
      validator(value: AlertType) {
        return Object.values(AlertType).includes(value)
      },
      default: AlertType.DEFAULT
    }
  },
  computed: {
    alertSelector() {
      switch (this.alertType) {
      case AlertType.ERROR:
        return 'alert-error'
      case AlertType.INFO:
        return 'alert-info'
      case AlertType.SUCCESS:
        return 'alert-success'
      default:
        return null
      }
    }
  }
})
</script>
